Index: sasmodels/models/surface_fractal.c
===================================================================
--- sasmodels/models/surface_fractal.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/surface_fractal.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -1,2 +1,5 @@
+// Don't need invalid test since fractal_dim_surf is not polydisperse
+// #define INVALID(v) (v.fractal_dim_surf <= 1.0 || v.fractal_dim_surf >= 3.0)
+
 double form_volume(double radius);
 
@@ -11,27 +14,28 @@
     double cutoff_length)
 {
-    double pq, sq, mmo, result;
+    // calculate P(q)
+    const double pq = square(sas_3j1x_x(q*radius));
 
-    //Replaced the original formula with Taylor expansion near zero.
-    //pq = pow((3.0*(sin(q*radius) - q*radius*cos(q*radius))/pow((q*radius),3)),2);
+    // calculate S(q)
+    // Note: lim q->0 S(q) = -gamma(mmo) cutoff_length^mmo (mmo cutoff_length)
+    // however, the surface fractal formula is invalid outside the range
+    const double mmo = 5.0 - fractal_dim_surf;
+    const double sq = sas_gamma(mmo) * pow(cutoff_length, mmo)
+           * pow(1.0 + square(q*cutoff_length), -0.5*mmo)
+           * sin(-mmo * atan(q*cutoff_length)) / q;
 
-    pq = sph_j1c(q*radius);
-    pq = pq*pq;
+    // Empirically determined that the results are valid within this range.
+    // Above 1/r, the form starts to oscillate;  below
+    //const double result = (q > 5./(3-fractal_dim_surf)/cutoff_length) && q < 1./radius
+    //                      ? pq * sq : 0.);
 
-    //calculate S(q)
-    mmo = 5.0 - fractal_dim_surf;
-    sq  = sas_gamma(mmo)*sin(-(mmo)*atan(q*cutoff_length));
-    sq *= pow(cutoff_length, mmo);
-    sq /= pow((1.0 + (q*cutoff_length)*(q*cutoff_length)),(mmo/2.0));
-    sq /= q;
+    double result = pq * sq;
 
-    //combine and return
-    result = pq * sq;
-
-    return result;
+    // exclude negative results
+    return result > 0. ? result : 0.;
 }
-double form_volume(double radius){
-
-    return 1.333333333333333*M_PI*radius*radius*radius;
+double form_volume(double radius)
+{
+    return M_4PI_3*cube(radius);
 }
 
Index: sasmodels/models/surface_fractal.py
===================================================================
--- sasmodels/models/surface_fractal.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/surface_fractal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -10,37 +10,22 @@
 .. math::
 
-    I(q) = scale \times P(q)S(q) + background
-
-.. math::
-
-    P(q) = F(qR)^2
-
-.. math::
-
-    F(x) = \frac{3\left[sin(x)-xcos(x)\right]}{x^3}
-
-.. math::
-
-    S(q) = \frac{\Gamma(5-D_S)\zeta^{5-D_S}}{\left[1+(q\zeta)^2
-    \right]^{(5-D_S)/2}}
-    \frac{sin\left[(D_S - 5) tan^{-1}(q\zeta) \right]}{q}
-
-.. math::
-
-    scale = scale\_factor \times NV^2(\rho_{particle} - \rho_{solvent})^2
-
-.. math::
-
-    V = \frac{4}{3}\pi R^3
+    I(q) &= \text{scale} \times P(q)S(q) + \text{background} \\
+    P(q) &= F(qR)^2 \\
+    F(x) &= \frac{3\left[\sin(x)-x\cos(x)\right]}{x^3} \\
+    S(q) &= \Gamma(5-D_S)\xi^{\,5-D_S}\left[1+(q\xi)^2 \right]^{-(5-D_S)/2}
+            \sin\left[-(5-D_S) \tan^{-1}(q\xi) \right] q^{-1} \\
+    \text{scale} &= \text{scale_factor}\, N V^2(\rho_\text{particle} - \rho_\text{solvent})^2 \\
+    V &= \frac{4}{3}\pi R^3
 
 where $R$ is the radius of the building block, $D_S$ is the **surface** fractal
-dimension,| \zeta\|  is the cut-off length, $\rho_{solvent}$ is the scattering
-length density of the solvent,
-and $\rho_{particle}$ is the scattering length density of particles.
+dimension, $\xi$ is the cut-off length, $\rho_\text{solvent}$ is the scattering
+length density of the solvent and $\rho_\text{particle}$ is the scattering
+length density of particles.
 
 .. note::
-    The surface fractal dimension $D_s$ is only valid if $1<surface\_dim<3$.
-    It is also only valid over a limited $q$ range (see the reference for
-    details)
+
+    The surface fractal dimension is only valid if $1<D_S<3$. The result is
+    only valid over a limited $q$ range, $\tfrac{5}{3-D_S}\xi^{\,-1} < q < R^{-1}$.
+    See the reference for details.
 
 
@@ -87,7 +72,7 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/sas_gamma.c", "surface_fractal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sas_gamma.c", "surface_fractal.c"]
 
-demo = dict(scale=1, background=0,
+demo = dict(scale=1, background=1e-5,
             radius=10, fractal_dim_surf=2.0, cutoff_length=500)
 
Index: sasmodels/models/teubner_strey.py
===================================================================
--- sasmodels/models/teubner_strey.py	(revision b3f2a24980756e0d0b1e7b07be74b8df6c8674c5)
+++ sasmodels/models/teubner_strey.py	(revision 8393c74ed553108e237a0c93b1e6c65ff328e00d)
@@ -69,7 +69,8 @@
 B Jakobs, T Sottmann, R Strey, and I Grillo, *J. Chem. Phys.*, 115 (2001), 580
 """
+from __future__ import division
 
 import numpy as np
-from numpy import inf,power,pi
+from numpy import inf, pi
 
 name = "teubner_strey"
@@ -89,16 +90,12 @@
     ]
 
-def Iq(q, volfraction, sld, sld_solvent,d,xi):
+def Iq(q, volfraction_a, sld_a, sld_b, d, xi):
     """SAS form"""
-    drho2 = (sld-sld_solvent)*(sld-sld_solvent)
+    drho = sld_a - sld_b
     k = 2.0*pi*xi/d
-    a2 = power(1.0+power(k,2.0),2.0)
-    c1 = -2.0*xi*xi*power(k,2.0)+2*xi*xi
-    c2 = power(xi,4.0)
-    prefactor = 8.0*pi*volfraction*(1.0-volfraction)*drho2*c2/xi
-    #k2 = (2.0*pi/d)*(2.0*pi/d)
-    #xi2 = 1/(xi*xi)
-    #q2 = q*q
-    #result = prefactor/((xi2+k2)*(xi2+k2)+2.0*(xi2-k2)*q2+q2*q2)
+    a2 = (1.0 + k**2)**2
+    c1 = 2.0*xi**2 * (1.0 - k**2)
+    c2 = xi**4
+    prefactor = 8.0*pi * volfraction_a*(1.0 - volfraction_a) * drho**2 * c2/xi
     return 1.0e-4*prefactor / np.polyval([c2, c1, a2], q**2)
 
Index: sasmodels/models/triaxial_ellipsoid.c
===================================================================
--- sasmodels/models/triaxial_ellipsoid.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/triaxial_ellipsoid.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -10,5 +10,5 @@
 double form_volume(double radius_equat_minor, double radius_equat_major, double radius_polar)
 {
-    return 1.333333333333333*M_PI*radius_equat_minor*radius_equat_major*radius_polar;
+    return M_4PI_3*radius_equat_minor*radius_equat_major*radius_polar;
 }
 
@@ -37,5 +37,5 @@
             const double ysq = square(Gauss76Z[j]*zm + zb);
             const double t = q*sqrt(acosx2 + bsinx2*(1.0-ysq) + c2*ysq);
-            const double fq = sph_j1c(t);
+            const double fq = sas_3j1x_x(t);
             inner += Gauss76Wt[j] * fq * fq ;
         }
@@ -58,21 +58,11 @@
     double psi)
 {
-    double stheta, ctheta;
-    double sphi, cphi;
-    double spsi, cpsi;
+    double q, calpha, cmu, cnu;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, calpha, cmu, cnu);
 
-    const double q = sqrt(qx*qx + qy*qy);
-    const double qxhat = qx/q;
-    const double qyhat = qy/q;
-    SINCOS(theta*M_PI_180, stheta, ctheta);
-    SINCOS(phi*M_PI_180, sphi, cphi);
-    SINCOS(psi*M_PI_180, spsi, cpsi);
-    const double calpha = ctheta*cphi*qxhat + stheta*qyhat;
-    const double cnu = (-cphi*spsi*stheta + sphi*cpsi)*qxhat + spsi*ctheta*qyhat;
-    const double cmu = (-stheta*cpsi*cphi - spsi*sphi)*qxhat + ctheta*cpsi*qyhat;
     const double t = q*sqrt(radius_equat_minor*radius_equat_minor*cnu*cnu
                           + radius_equat_major*radius_equat_major*cmu*cmu
                           + radius_polar*radius_polar*calpha*calpha);
-    const double fq = sph_j1c(t);
+    const double fq = sas_3j1x_x(t);
     const double s = (sld - sld_solvent) * form_volume(radius_equat_minor, radius_equat_major, radius_polar);
 
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 416f5c7f5af38d5e5d926a5b6b140a94e7e60502)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -104,5 +104,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "lib/gauss76.c", "triaxial_ellipsoid.c"]
+source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "triaxial_ellipsoid.c"]
 
 def ER(radius_equat_minor, radius_equat_major, radius_polar):
Index: sasmodels/models/unified_power_Rg.py
===================================================================
--- sasmodels/models/unified_power_Rg.py	(revision b3f2a24980756e0d0b1e7b07be74b8df6c8674c5)
+++ sasmodels/models/unified_power_Rg.py	(revision 66ca2a6cf404d09b601f9022e85222304a98dc8e)
@@ -3,8 +3,8 @@
 ----------
 
-The Beaucage model employs the empirical multiple level unified
-Exponential/Power-law fit method developed by G. Beaucage. Four functions
-are included so that 1, 2, 3, or 4 levels can be used. In addition a 0 level
-has been added which simply calculates
+This model employs the empirical multiple level unified Exponential/Power-law 
+fit method developed by Beaucage. Four functions are included so that 1, 2, 3, 
+or 4 levels can be used. In addition a 0 level has been added which simply 
+calculates
 
 .. math::
@@ -15,4 +15,12 @@
 many different types of particles, including fractal clusters, random coils
 (Debye equation), ellipsoidal particles, etc.
+
+The model works best for mass fractal systems characterized by Porod exponents 
+between 5/3 and 3. It should not be used for surface fractal systems. Hammouda 
+(2010) has pointed out a deficiency in the way this model handles the 
+transitioning between the Guinier and Porod regimes and which can create 
+artefacts that appear as kinks in the fitted model function.
+
+Also see the Guinier_Porod model.
 
 The empirical fit function is:
@@ -30,5 +38,7 @@
 .. math::
 
-    q_i^* = \frac{q}{\operatorname{erf}^3(q R_{gi}/\sqrt{6}}
+    q_i^* = q \left[\operatorname{erf}
+            \left(\frac{q R_{gi}}{\sqrt{6}}\right)
+        \right]^{-3}
 
 
@@ -56,4 +66,6 @@
 
 G Beaucage, *J. Appl. Cryst.*, 29 (1996) 134-146
+
+B Hammouda, *Analysis of the Beaucage model, J. Appl. Cryst.*, (2010), 43, 1474-1478
 
 """
Index: sasmodels/models/vesicle.c
===================================================================
--- sasmodels/models/vesicle.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/vesicle.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -8,8 +8,5 @@
 {
     //note that for the vesicle model, the volume is ONLY the shell volume
-    double volume;
-    volume =4.*M_PI*(radius+thickness)*(radius+thickness)*(radius+thickness)/3;
-    volume -=4.*M_PI*radius*radius*radius/3.;
-    return volume;
+    return M_4PI_3*(cube(radius+thickness) - cube(radius));
 }
 
@@ -32,15 +29,15 @@
     // core first, then add in shell
     contrast = sld_solvent-sld;
-    vol = 4.0*M_PI/3.0*radius*radius*radius;
-    f = vol*sph_j1c(q*radius)*contrast;
+    vol = M_4PI_3*cube(radius);
+    f = vol * sas_3j1x_x(q*radius) * contrast;
  
     //now the shell. No volume normalization as this is done by the caller
     contrast = sld-sld_solvent;
-    vol = 4.0*M_PI/3.0*(radius+thickness)*(radius+thickness)*(radius+thickness);
-    f += vol*sph_j1c(q*(radius+thickness))*contrast;
+    vol = M_4PI_3*cube(radius+thickness);
+    f += vol * sas_3j1x_x(q*(radius+thickness)) * contrast;
 
     //rescale to [cm-1]. 
-    f2 = volfraction*f*f*1.0e-4;
+    f2 = volfraction * f*f*1.0e-4;
     
-    return(f2);
+    return f2;
 }
Index: sasmodels/models/vesicle.py
===================================================================
--- sasmodels/models/vesicle.py	(revision e77872ef7445f58a9eb6ad1eb0015b7b63d53fac)
+++ sasmodels/models/vesicle.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -94,5 +94,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "vesicle.c"]
+source = ["lib/sas_3j1x_x.c", "vesicle.c"]
 
 def ER(radius, thickness):
@@ -116,6 +116,6 @@
     '''
 
-    whole = 4. * pi * (radius + thickness) ** 3. / 3.
-    core = 4. * pi * radius ** 3. / 3.
+    whole = 4./3. * pi * (radius + thickness)**3
+    core = 4./3. * pi * radius**3
     return whole, whole - core
 
Index: sasmodels/resolution2d.py
===================================================================
--- sasmodels/resolution2d.py	(revision 40a87fa5096610e24c3ead10299f609e99f093f2)
+++ sasmodels/resolution2d.py	(revision 7e94989f214482b706d6c85060f63becff5d85ae)
@@ -64,9 +64,9 @@
         # just need q_calc and weights
         self.data = data
-        self.index = index
-
-        self.qx_data = data.qx_data[index]
-        self.qy_data = data.qy_data[index]
-        self.q_data = data.q_data[index]
+        self.index = index if index is not None else slice(None)
+
+        self.qx_data = data.qx_data[self.index]
+        self.qy_data = data.qy_data[self.index]
+        self.q_data = data.q_data[self.index]
 
         dqx = getattr(data, 'dqx_data', None)
@@ -74,6 +74,6 @@
         if dqx is not None and dqy is not None:
             # Here dqx and dqy mean dq_parr and dq_perp
-            self.dqx_data = dqx[index]
-            self.dqy_data = dqy[index]
+            self.dqx_data = dqx[self.index]
+            self.dqy_data = dqy[self.index]
             ## Remove singular points if exists
             self.dqx_data[self.dqx_data < SIGMA_ZERO] = SIGMA_ZERO
@@ -126,5 +126,5 @@
         # The angle (phi) of the original q point
         q_phi = np.arctan(q_phi).repeat(nbins)\
-            .reshape(nq, nbins).transpose().flatten()
+            .reshape([nq, nbins]).transpose().flatten()
         ## Find Gaussian weight for each dq bins: The weight depends only
         #  on r-direction (The integration may not need)
Index: sasmodels/rst2html.py
===================================================================
--- sasmodels/rst2html.py	(revision b217c71eb4946b935994265074fdaf992f34b66f)
+++ sasmodels/rst2html.py	(revision 0890871751ed39056683fe16b7c50393b3d469f3)
@@ -155,4 +155,13 @@
     assert replace_dollar(u"a (again $in parens$) a") == u"a (again :math:`in parens`) a"
 
+def view_rst_app(filename):
+    import wx  # type: ignore
+    app = wx.App()
+    view_rst(filename)
+    app.MainLoop()
+
+
 if __name__ == "__main__":
-    test_dollar()
+    import sys
+    view_rst_app(sys.argv[1])
+
Index: sasmodels/sasview_model.py
===================================================================
--- sasmodels/sasview_model.py	(revision a80e64c6fabe2895c22d039441c659df03f77dfa)
+++ sasmodels/sasview_model.py	(revision 64614ad601c59ff9c1ee778c4fe0ac411d0696f3)
@@ -50,5 +50,5 @@
     """
     import sys
-    import sas
+    import sas   # needed in order to set sas.models
     import sas.sascalc.fit
     sys.modules['sas.models'] = sas.sascalc.fit
@@ -57,6 +57,8 @@
     import sas.models
     from sasmodels.conversion_table import CONVERSION_TABLE
-    for new_name, conversion in CONVERSION_TABLE.items():
-        old_name = conversion[0]
+    for new_name, conversion in CONVERSION_TABLE.get((3,1,2), {}).items():
+        # CoreShellEllipsoidModel => core_shell_ellipsoid:1
+        new_name = new_name.split(':')[0]
+        old_name = conversion[0] if len(conversion) < 3 else conversion[2]
         module_attrs = {old_name: find_model(new_name)}
         ConstructedModule = type(old_name, (), module_attrs)
@@ -228,5 +230,5 @@
     magnetic_params = []
     fixed = []
-    for p in model_info.parameters.user_parameters():
+    for p in model_info.parameters.user_parameters({}, is2d=True):
         if p.type == 'orientation':
             orientation_params.append(p.name)
@@ -352,5 +354,5 @@
         self.dispersion = collections.OrderedDict()
         self.details = {}
-        for p in self._model_info.parameters.user_parameters():
+        for p in self._model_info.parameters.user_parameters({}, is2d=True):
             if p.name in hidden:
                 continue
@@ -580,4 +582,16 @@
             raise TypeError("evalDistribution expects q or [qx, qy], not %r"
                             % type(qdist))
+
+    def get_composition_models(self):
+        """
+            Returns usable models that compose this model
+        """
+        s_model = None
+        p_model = None
+        if hasattr(self._model_info, "composition") \
+           and self._model_info.composition is not None:
+            p_model = _make_model_from_info(self._model_info.composition[1][0])()
+            s_model = _make_model_from_info(self._model_info.composition[1][1])()
+        return p_model, s_model
 
     def calculate_Iq(self, qx, qy=None):
